﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace pmOne.PowerBI.PowerBIObjects
{
    [DataContract]
    public class PBIColumn
    {
        #region Constructors
        public PBIColumn(string name, PowerBIClient_DataType dataType)
        {
            Name = name;
            DataType = dataType;
        }
        #endregion
        #region Private Properties for Serialization
        [DataMember(Name = "name", IsRequired = true)]
        private string _name;

        [DataMember(Name = "dataType", EmitDefaultValue = false)]
        private string _dataTypeString;
        #endregion

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public PowerBIClient_DataType DataType { 
            get
            {
                return (PowerBIClient_DataType)Enum.Parse(typeof(PowerBIClient_DataType), "PBI_" + _dataTypeString);
            }
            set
            {
                _dataTypeString = value.ToString().Replace("PBI_", "");
            }
        }

        public PBITable ParentTable { get; set; }
    }
}
