﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Text;
using System.Threading.Tasks;

namespace pmOne.PowerBI.PowerBIObjects
{
    public class PBIRow : Dictionary<string, object>
    {
        #region Public Properties
        public string JSON
        {
            get
            {
                StringBuilder sb = new StringBuilder();
                bool valueSet = false;

                sb.Append("{");

                foreach(KeyValuePair<string, object> kvp in this)
                {
                    if (kvp.Value != null)
                    {
                        string pattern = "{0},";

                        sb.Append("\"" + kvp.Key + "\":");

                        if (kvp.Value.GetType() == typeof(string))
                            pattern = "\"{0}\",";

                        sb.Append(string.Format(pattern, kvp.Value));
                        valueSet = true;
                    }
                }

                if (valueSet)
                {
                    sb.Remove(sb.Length - 1, 1);

                    sb.Append("}");

                    return sb.ToString();
                }
                else
                {
                    return "{}";
                }
                
            }
        }

        public PBITable ParentTable { get; set; }
        #endregion

        public void PublishToPowerBI(PowerBIClient powerBiAPI)
        {
            if (ParentTable == null)
                throw new Exception("Cannot add row to PowerBI table as the object is not linked to a Table in PowerBI!");
           
            ParentTable.AddRowToPowerBI(powerBiAPI, this);
        }
    }
}
